diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/State.java b/game/client/src/main/java/net/minecraft/client/render/renderer/State.java
new file mode 100644
index 000000000..1ec24cd49
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/State.java
@@ -0,0 +1,96 @@
+package net.minecraft.client.render.renderer;
+
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL41;
+
+public enum State {// Keep ordered so that most commonly used toggles have the lowest ordinals, should decrease average set state time
+    BLEND(GL41.GL_BLEND),
+    DEPTH_TEST(GL41.GL_DEPTH_TEST),
+    CULL_FACE(GL41.GL_CULL_FACE),
+    SCISSOR_TEST(GL41.GL_SCISSOR_TEST),
+    POLYGON_OFFSET_FILL(GL41.GL_POLYGON_OFFSET_FILL),
+    POLYGON_OFFSET_LINE(GL41.GL_POLYGON_OFFSET_LINE),
+    POLYGON_OFFSET_POINT(GL41.GL_POLYGON_OFFSET_POINT),
+    POLYGON_SMOOTH(GL41.GL_POLYGON_SMOOTH),
+    STENCIL_TEST(GL41.GL_STENCIL_TEST),
+    CLIP_DISTANCE0(GL41.GL_CLIP_DISTANCE0),
+    CLIP_DISTANCE1(GL41.GL_CLIP_DISTANCE1),
+    CLIP_DISTANCE2(GL41.GL_CLIP_DISTANCE2),
+    CLIP_DISTANCE3(GL41.GL_CLIP_DISTANCE3),
+    CLIP_DISTANCE4(GL41.GL_CLIP_DISTANCE4),
+    CLIP_DISTANCE5(GL41.GL_CLIP_DISTANCE5),
+    CLIP_DISTANCE6(GL41.GL_CLIP_DISTANCE6),
+    CLIP_DISTANCE7(GL41.GL_CLIP_DISTANCE7),
+    COLOR_LOGIC_OP(GL41.GL_COLOR_LOGIC_OP),
+    //        DEBUG_OUTPUT(GL43.GL_DEBUG_OUTPUT),
+    //        DEBUG_OUTPUT_SYNCHRONOUS(GL43.GL_DEBUG_OUTPUT_SYNCHRONOUS),
+    DEPTH_CLAMP(GL41.GL_DEPTH_CLAMP),
+    DITHER(GL41.GL_DITHER),
+    FRAMEBUFFER_SRGB(GL41.GL_FRAMEBUFFER_SRGB),
+    LINE_SMOOTH(GL41.GL_LINE_SMOOTH),
+    MULTISAMPLE(GL41.GL_MULTISAMPLE),
+    PRIMITIVE_RESTART(GL41.GL_PRIMITIVE_RESTART),
+    //        PRIMITIVE_RESTART_FIXED_INDEX(GL43.GL_PRIMITIVE_RESTART_FIXED_INDEX),
+    RASTERIZER_DISCARD(GL41.GL_RASTERIZER_DISCARD),
+    SAMPLE_ALPHA_TO_COVERAGE(GL41.GL_SAMPLE_ALPHA_TO_COVERAGE),
+    SAMPLE_ALPHA_TO_ONE(GL41.GL_SAMPLE_ALPHA_TO_ONE),
+    SAMPLE_COVERAGE(GL41.GL_SAMPLE_COVERAGE),
+    SAMPLE_SHADING(GL41.GL_SAMPLE_SHADING),
+    SAMPLE_MASK(GL41.GL_SAMPLE_MASK),
+    TEXTURE_CUBE_MAP_SEAMLESS(GL41.GL_TEXTURE_CUBE_MAP_SEAMLESS),
+    PROGRAM_POINT_SIZE(GL41.GL_PROGRAM_POINT_SIZE);
+
+    private static final int COUNT = values().length;
+    private static final @NotNull net.minecraft.client.render.renderer.State @NotNull [] TOGGLES = values();
+
+    public final int cap;
+    public final long bitMask;
+
+    State(int cap) {
+        this.cap = cap;
+        this.bitMask = 1L << ordinal();
+    }
+
+    long enable(long config) {
+        return config | this.bitMask;
+    }
+
+    long disable(long config) {
+        return config & ~this.bitMask;
+    }
+
+    boolean isEnabled(long config) {
+        return (config & this.bitMask) != 0;
+    }
+
+    boolean isSystemEnabled() {
+        return GL41.glIsEnabled(this.cap);
+    }
+
+    private static long getSystemStateConfig() {
+        long currentConfig = 0L;
+        for (int i = 0; i < net.minecraft.client.render.renderer.State.COUNT; i++) {
+            net.minecraft.client.render.renderer.State t = net.minecraft.client.render.renderer.State.TOGGLES[i];
+            if (t.isSystemEnabled()) {
+                currentConfig |= t.bitMask;
+            }
+        }
+        return currentConfig;
+    }
+
+    static void setStateConfig(long currentConfig, long newConfig) {
+        if (currentConfig == newConfig) return;
+        long difConfig = currentConfig ^ newConfig; // Differences between configs
+        int max = 64 - Long.numberOfLeadingZeros(difConfig); // Number of bits until reaching the highest difference bit
+        for (int i = 0; i < max; i++) {
+            if ((difConfig >> i & 0b1) != 0) { // If config differs from current
+                net.minecraft.client.render.renderer.State t = net.minecraft.client.render.renderer.State.TOGGLES[i];
+                if (t.isEnabled(newConfig)) {
+                    GL41.glEnable(t.cap);
+                } else {
+                    GL41.glDisable(t.cap);
+                }
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/PhotoModeRenderer.java b/game/client/src/main/java/net/minecraft/client/render/shader/PhotoModeRenderer.java
index 1521e22b7..121307b0c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/PhotoModeRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/PhotoModeRenderer.java
@@ -5,41 +5,40 @@ import net.minecraft.client.gui.ScreenPhotoMode;
 
 public class PhotoModeRenderer extends ShadersRenderer {
 
-	public static final String[] shaders = new String[] { null, "blur", "silhouette", "vignette", "tiltshift", "outline", "outline2", "eerie", "sepia", "inverted", "distantblur" };
-
-	public final ScreenPhotoMode screen;
-
-	private int selectedShader = 0;
-
-	public PhotoModeRenderer(Minecraft minecraft, ScreenPhotoMode screen) {
-		super(minecraft);
-
-		this.screen = screen;
-		
-		if(!Shaders.enableShaders) throw new RuntimeException("Shaders disabled!");
-	}
-
-	@Override
-	public ShaderProvider getShader() {
-		if(selectedShader > 0) {
-			return new ShaderProviderInternal("/shaders/photo/" + getActiveShader() + "/");
-		} else {
-			return internal;
-		}
-	}
-	
-	public void next() {
-		selectedShader = (selectedShader + 1) % shaders.length;
-		reload();
-	}
-
-	public void first() {
-		selectedShader = 0;
-		reload();
-	}
-
-	public String getActiveShader() {
-		return shaders[selectedShader];
-	}
+    public static final String[] shaders = new String[]{null, "blur", "silhouette", "vignette", "tiltshift", "outline", "outline2", "eerie", "sepia", "inverted", "distantblur"};
+
+    public final ScreenPhotoMode screen;
+
+    private int selectedShader = 0;
+
+    public PhotoModeRenderer(Minecraft minecraft, ScreenPhotoMode screen) {
+        super(minecraft);
+
+        this.screen = screen;
+
+    }
+
+    @Override
+    public ShaderProvider getShader() {
+        if (this.selectedShader > 0) {
+            return new ShaderProviderInternal("/shaders/photo/" + getActiveShader() + "/");
+        } else {
+            return this.internal;
+        }
+    }
+
+    public void next() {
+        this.selectedShader = (this.selectedShader + 1) % shaders.length;
+        reload();
+    }
+
+    public void first() {
+        this.selectedShader = 0;
+        reload();
+    }
+
+    public String getActiveShader() {
+        return shaders[this.selectedShader];
+    }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
index e259f194f..d16c55ea5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
@@ -8,6 +8,7 @@ import java.util.Map;
 import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.client.render.OpenGLHelper;
 import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
@@ -22,7 +23,7 @@ public class Shader {
     public boolean supported = true;
     protected boolean enabled = false;
 
-    protected final Object2IntMap<String> uniformLocations = new Object2IntArrayMap<>();
+    protected final Object2IntMap<String> uniformLocations = new Object2IntOpenHashMap<>();
 
     public @NotNull Shader compile(@NotNull ShaderProvider folder, @NotNull String name) {
         if (!supported) return this;
@@ -91,8 +92,8 @@ public class Shader {
     }
 
     public int getUniform(String uniform) {
-        int location = this.uniformLocations.getOrDefault(uniform, -1);
-        if (location == -1) {
+        int location = this.uniformLocations.getOrDefault(uniform, -2);
+        if (location == -2) {
             location = glGetUniformLocation(this.program, uniform);
             this.uniformLocations.put(uniform, location);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/ShaderHelper.java b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderHelper.java
new file mode 100644
index 000000000..17d9258b2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderHelper.java
@@ -0,0 +1,126 @@
+
+package net.minecraft.client.render.shader;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.ScreenPhotoMode;
+import net.minecraft.client.render.camera.CameraUtil;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.RenderBuffer;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.item.ItemStack;
+import org.lwjgl.opengl.GL41;
+
+public final class ShaderHelper {
+    private static RenderBuffer fullScreenRect = null;
+
+    private static final long startTime = System.currentTimeMillis();
+    private static float frameTimeCounter = 0.0f;
+
+    private ShaderHelper() {
+
+    }
+
+    public static void drawFullscreenRect() {
+        if (fullScreenRect == null) {
+            int vao = GL41.glGenVertexArrays();
+            int vbo = GL41.glGenBuffers();
+
+            float[] quadVertices = new float[]{
+                -1.0f,   1.0f, 0.0f, 1.0f,
+                -1.0f,  -1.0f, 0.0f, 0.0f,
+                 1.0f,  1.0f,  1.0f, 1.0f,
+                 1.0f,  -1.0f, 1.0f, 0.0f,
+            };
+
+            GL41.glBindVertexArray(vao);
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
+
+            GL41.glBufferData(GL41.GL_ARRAY_BUFFER, quadVertices, GL41.GL_STATIC_DRAW);
+
+            GL41.glVertexAttribPointer(0, 2, GL41.GL_FLOAT, false, Float.BYTES * 4, 0);
+            GL41.glVertexAttribPointer(1, 2, GL41.GL_FLOAT, false, Float.BYTES * 4, Float.BYTES * 2);
+
+            GL41.glEnableVertexAttribArray(0);
+            GL41.glEnableVertexAttribArray(1);
+
+            GL41.glBindVertexArray(0);
+            fullScreenRect = new RenderBuffer(vao, vbo, 0, 6, DrawMode.TRIANGLES);
+        }
+
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.disableState(State.CULL_FACE);
+        GLRenderer.disableState(State.SCISSOR_TEST);
+
+        GL41.glBindVertexArray(fullScreenRect.vao());
+        GL41.glDrawArrays(GL41.GL_TRIANGLE_STRIP, 0, 4);
+        GL41.glBindVertexArray(0);
+    }
+
+    public static void setUniforms(Minecraft minecraft, Shader shader, float partialTicks) {
+        long now = System.currentTimeMillis();
+        int passedTime = (int) (now - startTime);
+        frameTimeCounter = passedTime / 1000.0f;
+
+        if (!shader.isEnabled()) return;
+
+        shader.bind();
+        shader.uniformFloat("width", minecraft.gameWindow.getWidthPixels());
+        shader.uniformFloat("height", minecraft.gameWindow.getHeightPixels());
+        shader.uniformFloat("frameTimeCounter", frameTimeCounter);
+        shader.uniformFloat("gamma", minecraft.gameSettings.gamma.value);
+        shader.uniformFloat("fxaa", minecraft.gameSettings.fxaa.value);
+        shader.uniformFloat("heatHaze", minecraft.gameSettings.heatHaze.value ? minecraft.ppm.lerped.heatHaze : 0.0f);
+        shader.uniformInt("bloom", minecraft.gameSettings.bloom.value);
+        shader.uniformInt("dimension", minecraft.currentWorld != null && minecraft.currentWorld.dimension != null ? minecraft.currentWorld.dimension.id : 0);
+        shader.uniformInt("cbCorrectionMode", minecraft.gameSettings.colorblindnessFix.value.ordinal());
+
+        ItemStack helmet = minecraft.thePlayer == null ? null : minecraft.thePlayer.getItemInArmorSlot(HumanArmorShape.HEAD);
+        shader.uniformInt("shaderEffect", helmet != null && helmet.itemID == Blocks.PUMPKIN_REDSTONE.id() ? 1 : 0);
+
+        int isEyeInLiquid = 0;
+        float celestialAngle = 0.0f;
+        if (minecraft.thePlayer != null && minecraft.currentWorld != null && minecraft.activeCamera != null) {
+            if (CameraUtil.isUnderLiquid(minecraft.activeCamera, minecraft.currentWorld, Materials.LAVA, partialTicks)) {
+                isEyeInLiquid = 2;
+            } else if (CameraUtil.isUnderLiquid(minecraft.activeCamera, minecraft.currentWorld, Materials.WATER, partialTicks)) {
+                isEyeInLiquid = 1;
+            }
+            celestialAngle = minecraft.currentWorld.getCelestialAngle(partialTicks);
+        }
+        shader.uniformInt("isEyeInLiquid", isEyeInLiquid);
+        shader.uniformFloat("celestialAngle", celestialAngle);
+
+        if (minecraft.ppm.enabled) {
+            shader.uniformFloat("brightness", minecraft.ppm.lerped.brightness);
+            shader.uniformFloat("contrast", minecraft.ppm.lerped.contrast);
+            shader.uniformFloat("exposure", minecraft.ppm.lerped.exposure);
+            shader.uniformFloat("saturation", minecraft.ppm.lerped.saturation);
+            shader.uniformFloat("rMod", minecraft.ppm.lerped.rMod);
+            shader.uniformFloat("gMod", minecraft.ppm.lerped.gMod);
+            shader.uniformFloat("bMod", minecraft.ppm.lerped.bMod);
+        } else {
+            shader.uniformFloat("brightness", 0.0f);
+            shader.uniformFloat("contrast", 0.0f);
+            shader.uniformFloat("exposure", 0.0f);
+            shader.uniformFloat("saturation", 0.0f);
+            shader.uniformFloat("rMod", 1.0f);
+            shader.uniformFloat("gMod", 1.0f);
+            shader.uniformFloat("bMod", 1.0f);
+        }
+        shader.uniformFloat("photoMode", minecraft.currentScreen instanceof ScreenPhotoMode);
+        shader.uniformFloat("guiOpened", minecraft.currentScreen != null);
+
+        if (minecraft.currentScreen instanceof ScreenPhotoMode screenPhotoMode) {
+            shader.uniformFloat("intensity", screenPhotoMode.intensityValue);
+        } else {
+            shader.uniformFloat("intensity", 1.0f);
+        }
+    }
+
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/ShaderProviderInternal.java b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderProviderInternal.java
index da6097a29..afb41fe6b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/ShaderProviderInternal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderProviderInternal.java
@@ -4,6 +4,7 @@ import java.io.InputStream;
 
 import com.b100.utils.StringUtils;
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
 import org.slf4j.Logger;
 
 public class ShaderProviderInternal implements ShaderProvider {
@@ -16,9 +17,9 @@ public class ShaderProviderInternal implements ShaderProvider {
 	
 	@Override
 	public String getShaderSource(String name) {
-		String path = dir + name;
+		String path = this.dir + name;
 
-        try (InputStream stream = ShaderProviderInternal.class.getResourceAsStream(dir + name)) {
+        try (InputStream stream = Minecraft.getMinecraft().texturePackList.getResourceAsStream(this.dir + name)) {
             if (stream != null) {
                 return StringUtils.readInputString(stream);
             } else {
@@ -26,7 +27,7 @@ public class ShaderProviderInternal implements ShaderProvider {
                 return null;
             }
         } catch (Exception e) {
-            LOGGER.error("Exception reading shader resource '{}{}'!", dir, name, e);
+            LOGGER.error("Exception reading shader resource '{}{}'!", this.dir, name, e);
             return null;
         }
 	}
